Attribute VB_Name = "MTransBlt"
Option Explicit
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function GetObj Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Private Declare Sub GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT)

Private Const CAPS1 = 94
Private Const C1_TRANSPARENT = &H1
Private Const NEWTRANSPARENT = 3
Private Const OBJ_BITMAP = 7

Private Const SRCCOPY = &HCC0020
Private Const SRCPAINT = &HEE0086
Private Const SRCAND = &H8800C6
Private Const NOTSRCCOPY = &H330008

Public Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type BITMAP
   bmType As Long
   bmWidth As Long
   bmHeight As Long
   bmWidthBytes As Long
   bmPlanes As Integer
   bmBitsPixel As Integer
   bmBits As Long
End Type

Public Sub TileBlt(ByVal hWndDest As Long, ByVal hBmpSrc As Long)
  
' Riempie l'area client con la ripetizione di una Bitmap.
' Tiles a bitmap across the client area of destination window.
' hWndDest:     hWnd di Destinazione , hWnd of destination
' hBmpSrc:      hBitmap del immagine , hBitmap of source
   
   Dim bmp As BITMAP
   Dim hDCSrc As Long
   Dim hDCDest As Long
   Dim hBmpTmp As Long
   Dim dRect As RECT
   Dim Rows As Long
   Dim Cols As Long
   Dim dX As Long
   Dim dY As Long
   Dim i As Long, j As Long
   
   Call GetClientRect(hWndDest, dRect)
   hDCDest = GetDC(hWndDest)
   
   hDCSrc = CreateCompatibleDC(hDCDest)
   hBmpTmp = SelectObject(hDCSrc, hBmpSrc)
   
   Call GetObj(hBmpSrc, Len(bmp), bmp)
   Rows = dRect.Right \ bmp.bmWidth
   Cols = dRect.Bottom \ bmp.bmHeight
   
   For i = 0 To Rows
      dX = i * bmp.bmWidth
      For j = 0 To Cols
         dY = j * bmp.bmHeight
         Call BitBlt(hDCDest, dX, dY, bmp.bmWidth, bmp.bmHeight, hDCSrc, 0, 0, SRCCOPY)
      Next j
   Next i
   
   Call SelectObject(hDCSrc, hBmpTmp)
   Call DeleteDC(hDCSrc)
   Call ReleaseDC(hWndDest, hDCDest)

End Sub

Public Sub TransBlt(ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal TransColor As Long)
   
'Rende trasparente un immagine
'Makes an image transparent
'hDestDC:     Device context di destinazione
'             Destination device context
'x, y:        Coordinate del punto in alto a sinistra
'             della destinazione(in pixels)
'             Upper-left destination coordinates (pixels)
'nWidth:      Larghezza della Destinazione
'             Width of destination
'nHeight:     Altezza della destinazione
'             Height of destination
'hSrcDC:      Device context sorgente , Source device context
'xSrc, ySrc:  Coordinate punto in alto a sinistra della
'             destinazione (in pixels)
'             Upper-left source coordinates (pixels)
'TransColor:  Valore Rgb per i pixel trasparenti,tipicamente
'             &HC0C0C0.
'             RGB value for transparent pixels, typically
'             &HC0C0C0.
   
   Dim OrigColor As Long
   Dim OrigMode As Long
   
   If (GetDeviceCaps(hDestDC, CAPS1) And C1_TRANSPARENT) Then
      
      OrigMode = SetBkMode(hDestDC, NEWTRANSPARENT)
      OrigColor = SetBkColor(hDestDC, TransColor)
      Call BitBlt(hDestDC, x, y, nWidth, nHeight, hSrcDC, xSrc, ySrc, SRCCOPY)
      Call SetBkColor(hDestDC, OrigColor)
      Call SetBkMode(hDestDC, OrigMode)
      
   Else
      
      Dim saveDC As Long
      Dim maskDC As Long
      Dim invDC As Long
      Dim resultDC As Long
      Dim hSaveBmp As Long
      Dim hMaskBmp As Long
      Dim hInvBmp As Long
      Dim hResultBmp As Long
      Dim hSavePrevBmp As Long
      Dim hMaskPrevBmp As Long
      Dim hInvPrevBmp As Long
      Dim hDestPrevBmp As Long
      
      saveDC = CreateCompatibleDC(hDestDC)
      maskDC = CreateCompatibleDC(hDestDC)
      invDC = CreateCompatibleDC(hDestDC)
      resultDC = CreateCompatibleDC(hDestDC)
      
      hMaskBmp = CreateBitmap(nWidth, nHeight, 1, 1, ByVal 0&)
      hInvBmp = CreateBitmap(nWidth, nHeight, 1, 1, ByVal 0&)
      
      hResultBmp = CreateCompatibleBitmap(hDestDC, nWidth, nHeight)
      hSaveBmp = CreateCompatibleBitmap(hDestDC, nWidth, nHeight)
      
      hSavePrevBmp = SelectObject(saveDC, hSaveBmp)
      hMaskPrevBmp = SelectObject(maskDC, hMaskBmp)
      hInvPrevBmp = SelectObject(invDC, hInvBmp)
      hDestPrevBmp = SelectObject(resultDC, hResultBmp)
      
      OrigColor = SetBkColor(hSrcDC, TransColor)
      Call BitBlt(maskDC, 0, 0, nWidth, nHeight, hSrcDC, xSrc, ySrc, vbSrcCopy)
      TransColor = SetBkColor(hSrcDC, OrigColor)
      
      Call BitBlt(invDC, 0, 0, nWidth, nHeight, maskDC, 0, 0, vbNotSrcCopy)
      
      Call BitBlt(resultDC, 0, 0, nWidth, nHeight, hDestDC, x, y, vbSrcCopy)
      
      Call BitBlt(resultDC, 0, 0, nWidth, nHeight, maskDC, 0, 0, vbSrcAnd)
      
      Call BitBlt(saveDC, 0, 0, nWidth, nHeight, hSrcDC, xSrc, ySrc, vbSrcCopy)
      
      Call BitBlt(saveDC, 0, 0, nWidth, nHeight, invDC, 0, 0, vbSrcAnd)
      
      Call BitBlt(resultDC, 0, 0, nWidth, nHeight, saveDC, 0, 0, vbSrcInvert)
      
      Call BitBlt(hDestDC, x, y, nWidth, nHeight, resultDC, 0, 0, vbSrcCopy)
      
      Call SelectObject(saveDC, hSavePrevBmp)
      Call SelectObject(resultDC, hDestPrevBmp)
      Call SelectObject(maskDC, hMaskPrevBmp)
      Call SelectObject(invDC, hInvPrevBmp)
      
      Call DeleteObject(hSaveBmp)
      Call DeleteObject(hMaskBmp)
      Call DeleteObject(hInvBmp)
      Call DeleteObject(hResultBmp)
      Call DeleteDC(saveDC)
      Call DeleteDC(invDC)
      Call DeleteDC(maskDC)
      Call DeleteDC(resultDC)
   
   End If

End Sub

